

#==============================================================================
#  File_Bitmap2 par King Kadelfek
#------------------------------------------------------------------------------
#  Script permettant de crer des fichiers bmp  partir d'un bitmap dans le buffer.
#==============================================================================


class Bitmap

  def save(name="new_bitmap.bmp")


    path = File.join(".", name)

    bmp = self

    Thread.new{
        sleep 9
        Graphics.update
    }

    file = DA::file_open(path, "wb")

    bmp_width = bmp.width
    bmp_height = bmp.height

    ligne_max = bmp_width*3+bmp_width%4

    const_1 = [66, 77]

    taille_fichier = 100
    cod_fichier = code_octet(taille_fichier, 8)

    const_2 = [54, 0, 0, 0]
    const_3 = [40, 0, 0, 0]

    cod_width = code_octet(bmp_width, 4)
    cod_height = code_octet(bmp_height, 4)

    const_4 = [1, 0, 24, 0, 0, 0, 0, 0]

    taille_image = ligne_max*bmp_height
    cod_image = code_octet(taille_image, 20)

    # Pas  sa place
    taille_fichier = taille_image+54
    cod_fichier = code_octet(taille_fichier, 8)
    # Pas  sa place

    liste = const_1+cod_fichier+const_2+const_3+cod_width+cod_height+const_4+cod_image

    for octet in liste
      file.putc(octet)
    end

    # Octets de valeur 0  la fin de chaque ligne
    complement = ligne_max-bmp_width


    if complement == 0

      raise "pas bon (file_bitmap2)"
      ##############################################
      for j in 0..bmp_height-1
        for i in 0..bmp_width-1
          color = bmp.get_pixel(i, bmp_height-j-1)
          file.putc(color.blue)
          file.putc(color.green)
          file.putc(color.red)
        end

      end
      #############################################

    else # if complement

      ##############################################
      
      tablo = []

      for j in 0..bmp_height-1
        for i in 0..bmp_width-1
          color = bmp.get_pixel(i, bmp_height-j-1)
          tablo.push(color.blue.to_i)
          tablo.push(color.green.to_i)
          tablo.push(color.red.to_i)
        end

        # Cration du complment de 0
        for k in (i+1)*3..ligne_max-1
          tablo.push(0)
        end


      end
      #############################################

      file.write(tablo.pack("c*"))

    end 

    file.close

  end





  def code_octet(nombre, nb_zero)

    #nb_zero = 8
    #nombre = 245789

    tab = []

    nombre = nombre.to_i

    for i in 0..nb_zero-1
      fact = (256**(nb_zero-i-1))
      num = nombre/fact
      tab[nb_zero-i-1] = num
      nombre -= num*fact
    end

    return tab

  end


  def decode_octet(arr)

    max = arr.size-1
    total = 0

    for i in 0..max
      x = arr[i]
      #p x
      total += x.to_i*(256**i)
      #p x.to_i, total

    end

    return total
  end

end