begin
  require "zlib"
rescue LoadError
  
end

def creer_script(list, name="", contenu="", indentation=0)
  return if indentation < 0
  name = "  "*indentation+name
  contenu.gsub!("\n", "\r\n")
  contenu = contenu.convert_utf8
  script = [0, name, Zlib::Deflate.deflate(contenu)]
  list << script
  #puts name
end


# Fabrique un fichier scripts  partir des fichiers ruby lists
# dans require.txt
def fabriquer_script(application_dir)

  path_script = File.join(application_dir, "Data/scripts.rxdata")

  # Lecture du fichier de require
  contenu = DA::lire_fichier("require.txt")

  reg_commun = /.*\.\.\/\.\.\/Common\/lib\//


  old_nb = 0
  old_morceaux = []
  titre = {}
  old_tit = nil

  list = contenu.split("\n")
  puts "Scripts : #{list.size}"
  list_scr = []
  for path in list
    pat = path.sub(reg_commun, "./Common/")
    #p pat
    morceaux = pat.split("/")
    nb = morceaux.size

    fait = false

    tit = morceaux[morceaux.size-2]

    if morceaux.size != old_nb
      old_nb = nb
      old_morceaux = morceaux
      creer_script(list_scr) if list_scr != []
      fait = true
    end
    if morceaux.size > old_nb or tit != old_tit
      old_tit = tit
      old_nb = nb
      old_morceaux = morceaux
      creer_script(list_scr) if fait == false
      creer_script(list_scr, "#### "+tit, "", morceaux.size-4)
    end
    cc = DA::lire_fichier(path)
    #doc_rmxp(cc)
    name = File.basename(path, ".rb")
    creer_script(list_scr, name, cc, morceaux.size-3)
  end

  DA::ecrire_marshal(path_script, list_scr)

end


