﻿#==============================================================================
# -  King_RMXP par King Kadelfek
#------------------------------------------------------------------------------
#
#==============================================================================

class King_RMXP
  
  # Permet de recomposer le chemin d'une erreur à partir de son backtrace
  def self.chemin(backtrace)

    liste = []
    for back in backtrace
      m = back.scan(/(\d+):(\d+).+`(.+)'|(\d+):(\d+)/)
      if m.size > 0
        liste.push(m[0].compact!)
      else
        liste.push(back)
      end
    end

    # On récupère les numéros des scripts concernés
    @nums = []

    liste.each{|x|
      @nums.push(x[0].to_i)
    }

    # On ouvre le fichier Script pour récupérer les noms de scripts
    path = "Data/Scripts.rxdata"
    scripts = DA::marshal_read(path)

    # On crée le message à renvoyer
    message = ""

    for i in 0...@nums.size
      # Le message est composé de lignes contenant :
      # - le nom du script
      # - la ligne concernée
      # - le nom de la fonction où se trouve l'erreur
      message << "de #{scripts[@nums[i]][1]} (#{liste[i][1]}) dans #{liste[i][2]}\n"
    end

    message = message[0...message.size-7]

    # On renvoie le message
    return message

  end

  # Enregistre une erreur dans le fichier de dernière erreur
  def self.erreur_log(erreur)
    DA::file_write("erreur_log.txt", erreur)
  end
end